# Node Token Generator

Last Updated : June 10th 2024

This is a simple node script designed to generate tokens from multiple sets of claims and keys with minimal code changes required. This readme will cover exaectly where and how to edit variables in the script to produce the desired token. 

## Prerequisites 
Node 18.x  \
Jsonwebtoken library - can be installed with
```
npm i -g "jsonwebtoken"
```
## Usage

1. Begin by putting JSON file(s) containing the desired claims under the claims folder in the script home directory. This script will automatically pull each file when run and uses an editable variable to determine while file to use in the token generation.

2. Put the desired keys for signing and validating generated tokens under the keys folder. The path to these keys will need to be explicitly referenced in the code under the variables "publicKey" and "privateKey"

3. Edit the variables used to generate the token to the desired values, starting on line 12 and ending on line 19.

Keys -
```
const publicKey = fs.readFileSync("YOUR_PUBLIC_KEY_FILEPATH");
const privateKey = fs.readFileSync("YOUR_PRIVATE_KEY_FILEPATH");
```
Algorithm - 
```
const keyAlgorithm = "YOUR_KEYS_ALGORITHM";
Example - EC256, RS256
```

Desired Claims Json - exclude the file extension
```
const usedClaims = "IdToken";
```

Desired expiry - this token generator uses second precision, desired expiry is generated as additional seconds from the current timestamp. For example setting this value to 60 would cause the token to expire in one minute. The default is one day.

```
const desiredExpiry = (86400);
```
